/*
 * @Copyright   Copyright 2006-2013, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.design.ui.alignmentdialog
 *
 * @revision    $$
 */
/*jslint nomen: true, browser: true, vars: true*/
/*global define*/
define('de_epages/design/ui/cookiemessage', [
    'jquery/ui/widget',
    'ep/ui/simpledialog',
    'de_epages',
    '$tmpl!./cookiemessage',
    '$dict!ep/dict'
], function ($, ep, de_epages, template, dict) {
    'use strict';

    var COOKIE_CONTENT = 'epagescookielawcookie=1';

    function htmlDecode(value) {
        return $('<div/>').html(value).text();
    }

    $.widget('ui.designUiCookiemessage', {

        _create: function () {
            var self = this;
            this.options.message = htmlDecode(this.options.message);

            var message = template(this.options).find('span').dictParseAttr(dict, 'title').end();

            if (!this.acceptCookies()) {
                this.writeCookie();
                this.element.append(message);

                message.tmplItem('elements').close.one('click', function (event) {
                    message.tmplItem('elements').message.hide();
                });
            }
        },

        writeCookie: function () {
            document.cookie = COOKIE_CONTENT + ';expires=Fri, 01 Jan 2038 00:00:01 GMT'; // hopefully epages 7 is ready at this time
        },

        acceptCookies: function () {
            var cookies = document.cookie;
            return cookies.indexOf(COOKIE_CONTENT) !== -1;
        },

        // Destroy widget and its components.
        destroy: function () {
            return this._superApply(arguments);
        }
    });

    return de_epages;

});