/*jslint browser: true, vars:true*/
/*global define*/
define([
    'testsuite/qunit',
    'jquery',
    'de_epages/design/ui/cookiemessage',
    '$ready!'
], function (QUnit, $, de_epages) {

    'use strict';

    QUnit.module('de_epages/design/ui/cookiemessage', {
        setup: function () {
            // delete all cookies
            document.cookie = 'epagescookielawcookie=';
        }
    });

    var message = 'We use cookies on our site!';
    var link = '/privacypolicy';
    var linktext = 'Privacy Policy';
    var options = {
        'message': message,
        'link': link,
        'linktext': linktext
    };

    QUnit.test('Cookie message apears on first visit', function () {
        var $element = $('body');
        $element.designUiCookiemessage($element, options);

        QUnit.ok($('.message-bar.message-cookies:visible').length === 1, 'Cookie message is visible');

        $('.message-bar.message-cookies span').trigger('click');

        QUnit.ok($('.message-bar.message-cookies:visible').length === 0, 'Cookie message hides when clicking the x');

        // remove the dialog from the dom
        $('body .message-bar.message-cookies').remove();

        $element.designUiCookiemessage($element, options);

        QUnit.ok($('.message-bar.message-cookies:visible').length === 0, 'Cookie message doesn\'t show up again');

        // delete the cookie
        document.cookie = 'epagescookielawcookie=';

        $element.designUiCookiemessage($element, options);

        QUnit.ok($('.message-bar.message-cookies:visible').length === 0, 'Cookie message shown up again after deleting the cookie');
    });
});